
#include "ch554.h"

SBIT(P1_4,	0x90, 4);

void Timer2Interrupt(void) __interrupt (INT_NO_TMR2)  __naked
{
    
    __asm__("push	acc");
    __asm__("push	acc");
    __asm__("push	acc");
    __asm__("push	acc");
    __asm__("push	acc");
    __asm__("push	acc");
    __asm__("push	acc");
    __asm__("push	acc");
    __asm__("push	acc");
    __asm__("push	acc");
    __asm__("push	acc");
    __asm__("push	acc");
    __asm__("push	acc");
    __asm__("push	acc");
    timer2IntrHandler();//debugwire related
    __asm__("pop	acc");
    __asm__("pop	acc");
    __asm__("pop	acc");
    __asm__("pop	acc");
    __asm__("pop	acc");
    __asm__("pop	acc");
    __asm__("pop	acc");
    __asm__("pop	acc");
    __asm__("pop	acc");
    __asm__("pop	acc");
    __asm__("pop	acc");
    __asm__("pop	acc");
    __asm__("pop	acc");
    __asm__("pop	acc");


    __asm__("mov  r0, SP");
    __asm__("dec  r0");
    __asm__("push	acc");
    __asm__("pop	acc");
    __asm__("push	acc");
    __asm__("pop	acc");

    __asm__("reti");

}

void timer2IntrHandler() {
  if (TF2) {
    TF2 = 0;

    P1_4 = 0;

    // P1_4 = 0;

    __asm__("nop\nnop\n");
    __asm__("nop\nnop\n");
    __asm__("nop\nnop\n");
    __asm__("nop\nnop\n");
    __asm__("nop\nnop\n");
    __asm__("nop\nnop\n");
    __asm__("nop\nnop\n");
    __asm__("nop\nnop\n");
    __asm__("nop\nnop\n");
    __asm__("nop\nnop\n");
    __asm__("nop\nnop\n");
    __asm__("nop\nnop\n");
    __asm__("nop\nnop\n");
    __asm__("nop\nnop\n");

    P1_4 = 1;
  }
}
void main(void){
    // set internal clock
    SAFE_MOD = 0x55;
    SAFE_MOD = 0xAA;
    CLOCK_CFG = CLOCK_CFG & ~MASK_SYS_CK_SEL | 0x05; // 16MHz
    SAFE_MOD = 0x00;

    for (int i=0;i<5000;i++){
        __asm__("nop");
    }

    //delayMicroseconds(5000); // needed to stablize internal RC

    EA = 1; // millis and delay needs interrupt

    T2MOD |= bTMR_CLK; // set bTMR_CLK
    TR2 = 0;

    RCLK = 0;
    TCLK = 0;           // clear RCLK,TCLK in T2CON
    C_T2 = 0;           // clear C_T2 in T2CON for using internal clk
    EXEN2 = 0;          // clear EXEN2 in T2CON to disable T2EX
    T2MOD |= (bT2_CLK); // set bT2_CLK, for fast clk.Using Fsys/1
    CP_RL2 = 0;         // clear CP_RL2 in T2CON for 16bit timer, reload mode
    RCAP2 = 65535 - 128 + 1;


    TF2 = 0;
    EXF2 = 0;

    TR2 = 1; // start timer

    TL2 = 0x00; // seem only work when timer is on?
    TH2 = 0xFF;

    ET2 = 1;

    while(1){
        
    }
    

}